/*
CalendarView.h - Copyright (c) 1992 NeXT Computer, Inc.

You may freely copy, distribute and reuse the code in this example.
NeXT Computer, Inc. disclaims any warranty of any kind, expressed or implied, 
as to its fitness for any particular use.
*/

#import <appkit/View.h>
#include "time.h"

@interface CalendarView:View
{
	/* Archived Instance Variables */
	id		delegate;
	id		monthButton;
	id		monthPl;
	id		yearButton;
	id		yearPl;
	id		monthMatrix;
	id		dayLabelMatrix;
	id		buttonFont;
	id		cellFont;
	BOOL		useDelegate;
	
	/* scratch Instance Variables */
	struct	tm	theTime;
	struct	tm	*theTimePtr;		
	time_t		t;	
	NXRect		viewRect;
        NXSize		cellSize;
	int		yearBase;
	char		timeZone[10];
	char		tbuf[40];
}

- setupButtons;
- setFonts;
- loadMatrix;
- (struct tm *)currentDate;
- setCurrentDate:(struct tm *)theDate;
- dateChanged:sender;
- dayChanged:sender;
- (BOOL)useDelegate;
- setDoDelegate:anObject;
- (const char *)stringValue;

@end
