/*
	NXDataLinkPanel.h
	Application Kit, Release 3.0
	Copyright (c) 1991, NeXT, Inc.  All rights reserved.
*/

#import "NXDataLinkManager.h"
#import "Application.h"
#import "Panel.h"

@interface NXDataLinkPanel : Panel {
  /* these instance variables are NOT part of the API, are subject to change in future releases */
  @private
    id breakLink;
    id openSource;
    id updateDestination;
    id updateMode;
    id breakAllLinks;
    id showOutlines;
    id bannerMsg;
    id sourceTitle;
    id sourceValue;
    id lastUpdateTitle;
    id lastUpdateValue;
    id accessoryView;
    BOOL needsUpdate;
    BOOL reserved1;
    short reserved2;
}

+ new;
+ newContent:(const NXRect *)contentRect style:(int)aStyle backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag;

+ allocFromZone:(NXZone *)zone;
+ alloc;

+ setLink:(NXDataLink *)link andManager:(NXDataLinkManager *)linkManager isMultiple:(BOOL)flag;
+ getLink:(NXDataLink **)link andManager:(NXDataLinkManager **)linkManager isMultiple:(BOOL *)flag;

- setLink:(NXDataLink *)link andManager:(NXDataLinkManager *)linkManager isMultiple:(BOOL)flag;
- getLink:(NXDataLink **)link andManager:(NXDataLinkManager **)linkManager isMultiple:(BOOL *)flag;

- setAccessoryView:aView;
- accessoryView;

- pickedBreakLink:sender;
- pickedOpenSource:sender;
- pickedUpdateDestination:sender;
- pickedUpdateMode:sender;
- pickedBreakAllLinks:sender;

@end


@interface Application(NXDataLinkPanel)
- orderFrontDataLinkPanel:sender;
@end

