/*
	NXSelection
	Application Kit, Release 3.0
	Copyright (c) 1991, NeXT, Inc.  All rights reserved. 
*/

#import <objc/Object.h>
#import "Pasteboard.h"

extern NXAtom NXSelectionPboardType;

@interface NXSelection : Object {
  /* these instance variables are NOT part of the API, are subject to change in future releases */
  @private
    void *data;
    unsigned short length;
    struct _selFlags {
	unsigned int freeData:1;
	unsigned int isMagic:1;
	unsigned int RESERVED:14;
    } selFlags;
    unsigned int _reservedSel1;
}

/* these methods return special objects that indicate special selections */
+ emptySelection;		/* nothing selected */
+ allSelection;			/* the result of a select all */
+ currentSelection;		/* whatever is currently selected */

/* if count is -1, the data is assumed to be terminated by a zero byte */
/* data should be architecture independant and include a version stamp */
- initWithDescription:(const void *)desc length:(int)count;
- initWithDescriptionNoCopy:(const void *)desc length:(int)count;
- initFromPasteboard:(Pasteboard *)pasteboard;

- (const void *)descriptionOfLength:(int *)count;

- copyFromZone:(NXZone *)zone;
- (BOOL)isEqual:otherSel;

- writeToPasteboard:(Pasteboard *)pasteboard;

- (BOOL)isWellKnownSelection;

@end
