/* 	Copyright (c) 1992 NeXT Computer, Inc.  All rights reserved. 
 *
 * EventSrc.m - Common Event Source object class.
 *
 * HISTORY
 * 22 May 1992    Mike Paquette at NeXT
 *      Created. 
 */

#ifndef	_BSD_DEV_EVENT_SRC_
#define _BSD_DEV_EVENT_SRC_

#import <driverkit/IODevice.h>
#import <bsd/dev/EventProtocols.h>

@interface EventSrc : IODevice <EventSrcExported>
{
@private
	id		_owner;
	id		_desiredOwner;
	id		_ownerLock;		// NXLock; protects _owner and
						//   desiredOwner
}

- init;			// Called by subclass's init to set up ownership glue
- free;
/*
 * Methods used only by subclass.
 */
- owner;
- ownerLock;

@end
#endif	_BSD_DEV_EVENT_SRC_

