/* 	Copyright (c) 1991 NeXT Computer, Inc.  All rights reserved. 
 *
 * FloppyTypes.h - Private typedefs and #defines for FloppyDisk and FloppyCnt 
 *                 classes.
 *
 * HISTORY
 * 15-May-91    Doug Mitchell at NeXT
 *      Created. 
 */

#ifndef	_BSD_DEV_FLOPPYTYPES_H_
#define _BSD_DEV_FLOPPYTYPES_H_

#import <bsd/dev/fd_extern.h>
#import <bsd/dev/disk.h>
#import <driverkit/return.h>
#import <driverkit/driverTypes.h>
#ifdef	KERNEL_BUILD
#import "xpr_debug.h"
#endif	KERNEL_BUILD
#import <bsd/dev/FloppyCntPublic.h>

/*
 * Map from density to appropriate sector size info.
 */
typedef struct {
	u_int	density;
	struct	fd_sectsize_info *ssip;
} fdDensitySectsize_t;

/*
 * Standard command timeouts in milliseconds.
 */
#define FD_TIMEOUT_NORM		20000
#define FD_TIMEOUT_SIMPLE	5000
#define FD_TIMEOUT_SEEK		5000
#define FD_TIMEOUT_PIO		5000

#define FD_IDLE_TIME		2		// seconds to leave motor 
						// running while idle
#if 	i386
#define NUM_FD_UNITS	2		/* max # of drives per controller */ 
#else						
#define NUM_FD_UNITS	1		/* max # of drives per controller */ 
#endif

/* 
 * Global data in FloppyGlobals.m.
 */
extern fdDriveInfo_t fdDriveInfo[];
extern struct fd_disk_info fdDiskInfo[];
extern fdDensitySectsize_t fdDensitySectsize[];
extern fd_density_info_t fdDensityInfo[];
extern IONamedValue fdrValues[];
#ifdef	XPR_DEBUG
extern IONamedValue fdOpValues[];
extern IONamedValue fdCommandValues[];
extern IONamedValue fcOpcodeValues[];
extern IONamedValue densityValues[];
extern IONamedValue midValues[];
extern IONamedValue fdIoctlValues[];
#endif	XPR_DEBUG

#endif	_BSD_DEV_FLOPPYTYPES_H_


