/* 	Copyright (c) 1992 NeXT Computer, Inc.  All rights reserved. 
 *
 * IODisplay.h - Abstract superclass for all Display objects.
 *
 *
 * HISTORY
 * 01 Sep 92	Joe Pasqua
 *      Created. 
 */

// Notes:
// * This module defines an abstract superclass on which Display objects
//   can be built.

#import <driverkit/IODevice.h>
#import <driverkit/IODirectDevice.h>
#import	<bsd/dev/i386/ConsoleSupport.h>
#import	<bsd/dev/i386/displayDefs.h>
#import	<bsd/dev/EventProtocols.h>

@interface IODisplay: IODirectDevice <evScreen>
{
@private
    IODisplayInfo	_display;	// parameters describing the display
    int			_token;
}

- (IODisplayInfo *)displayInfo;
// Description:	Returns a pointer to an IODisplayInfo describing the display.

- (int)token;
// Returns the registration token for this display.

- (void)setToken:(int)token;
// Sets the token for this display

- (IOConsoleInfo *)allocateConsoleInfo;
// Description:	Allocates a console support info structure based on this
//		display. This structure, and the functions in it, are used
//		to display alert and console windows.


// evScreen protocol methods reimplemented by this class
- (port_t) devicePort;

@end





