/* 	Copyright (c) 1992 NeXT Computer, Inc.  All rights reserved. 
 *
 * VGAConsPriv.h - Private constants and typedefs for
 *                  VGAConsole implementation.
 *
 * HISTORY
 * 02 Feb 93	Peter Graffagnino
 *      Created from FBConsPriv.h
 */

/*
 * Standard font.
 */
extern char ohlfs12[][];
#import "ohlfs12.h"

/*
 * Framebuffer characteristics.
 */
#define FRAMEBUFFER_ADDRESS 0xa0000
#define TOTALWIDTH 1024
#define ROWBYTES 128
#define LINESPERBANK (0x10000 / ROWBYTES)

/*
 * Sizes (in pixels) for text and alert windows
 */
#define TEXT_WIN_WIDTH		600
#define TEXT_WIN_HEIGHT		450

#define ALERT_WIN_WIDTH		320
#define ALERT_WIN_HEIGHT	200

/*
 * Misc. constants.
 */
#define	TAB_SIZE		8		// in characters


/*
 * VGA Graphics Controller Port
 */

#define VGA_GC_ADDR		0x3CE
#define VGA_NUM_GC_REGS		9     	// number of graphics controller
					// registers to preserve
#define VGA_SEQ_ADDR		0x3C4
#define VGA_NUM_SEQ_REGS	5     	// number of sequencer
					// registers to preserve

/*
 * default graphics controller registers for mode 0x12
 */
static unsigned char defaultGCRegisters[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x0f, 0xff
};

/*
 * Standard NeXT colors (set up by DPS driver)
 */

#define VGA_WHITE	3		
#define VGA_LTGRAY	2		
#define VGA_DKGRAY	1		
#define VGA_BLACK	0		

