/*
 *	Copyright (C) 1989, NeXT, Inc.
 *
 * HISTORY
 *
 * 01-Mar-90  Ted Cohn (tcohn) at NeXT
 *	Added DKIOCREGISTER ioctl to register the MegaPixel with ev driver.
 *
 * 28-Feb-90  John Seamons (jks) at NeXT
 *	Added STOP_ANIM flag.
 *
 * 12-Aug-87  John Seamons (jks) at NeXT
 *	Created.
 */

#ifndef	_VIDEO_
#define	_VIDEO_

/* default display parameters */
#define VIDEO_W			1120	/* was 1120 */
#define VIDEO_MW		1120	/* was 1152 */
#define VIDEO_H			832	/* was 832  */
#define VIDEO_MH		832	/* was 910  */

#define	WHITE			0x00000000
#define	LT_GRAY			0x55555555
#define	DK_GRAY			0xaaaaaaaa
#define	BLACK			0xffffffff

/*
 * JAWS framebuffer (DELL)
 */
#define JAWS_VIDEO_W		VIDEO_W	/* 1120 x 832 mode */
#define JAWS_VIDEO_MW		VIDEO_MW
#define JAWS_VIDEO_H		VIDEO_H
#define JAWS_VIDEO_MH		VIDEO_MH
#define JAWS_VIDEO_NBPL		(JAWS_VIDEO_MW * 2)	/* 2 bytes/pixel */

#define JAWS_NPPW		2	/* 2 pixels per word. */
#define	JAWS_WHITE		0xFFF0FFF0
#define	JAWS_LT_GRAY		0xAAA0AAA0
#define	JAWS_DK_GRAY		0x55505550
#define	JAWS_BLACK		0

/*
 * COMPAQ 444
 */
#define COMPAQ_VIDEO_W		800
#define COMPAQ_VIDEO_MW		800
#define COMPAQ_VIDEO_H		(600-28)	/* Hardware BUG ?? */
#define COMPAQ_VIDEO_MH		(600-28)
#define COMPAQ_VIDEO_NBPL	(COMPAQ_VIDEO_MW * 2)	/* 2 bytes/pixel */

#define COMPAQ_NPPW		2	/* 2 pixels per word. */
#define	COMPAQ_WHITE		0xFFF0FFF0
#define	COMPAQ_LT_GRAY		0xAAA0AAA0
#define	COMPAQ_DK_GRAY		0x55505550
#define	COMPAQ_BLACK		0

#ifndef	ASSEMBLER
struct mwf {
    int min;		/* range of va's that need.. */
    int max;		/* ..to also map mem write funcs */
};

struct alarm {
	int	alarm_enabled;
	int	alarm_time;
};

#if !defined(__Bounds__) && !defined(BINTREE_H)
#define __Bounds__
typedef struct { short minx, maxx, miny, maxy; } Bounds;
#endif
#if !defined(__Point__) && !defined(BINTREE_H)
#define __Point__
typedef struct { short x, y; } Point;
#endif

struct vidRGBCursor {
    unsigned short image[4][256];
    unsigned short save[256];
};

typedef struct {
    int frame;
    int cursorSema;
    char cursorShow;
    char cursorObscured;
    char shieldFlag;
    char shielded;
    Bounds saveRect;
    Bounds shieldRect;
    Point cursorLoc;
    Bounds cursorRect;
    Bounds oldCursorRect;
    Bounds screenBounds;
    Point hotSpot[4];
    union {
	struct {
	    unsigned int image[4][16];
	    unsigned int mask[4][16];
	    unsigned int save[16];
	} bw;
	struct vidRGBCursor rgb;
    } cursor;
} vidShmemStruct;

#define VIDSETSEMA() if (msp->cursorSema) return 1; else msp->cursorSema = 1
#define VIDCLEARSEMA() msp->cursorSema = 0
#endif	ASSEMBLER

#define	DKIOCGADDR	_IOWR('v', 0, int)	/* get address of video mem */
#define	DKIOCSMWF	_IOWR('v', 1, struct mwf) /* set mwf bounds */
#define	DKIOCBRIGHT	_IOWR('v', 2, int)	/* get/set brightness */
#define	DKIOCDISABLE	_IO('v', 3)		/* disable translation */
#define	DKIOCGNVRAM	_IOR('v', 4, struct nvram_info) /* get NVRAM */
#define	DKIOCSNVRAM	_IOW('v', 4, struct nvram_info) /* set NVRAM */
#define	DKIOCREGISTER	_IO('v', 5)			/* register screen */
#define	DKIOCGFBINFO	_IO('v', 6) /* Get info on built-in frame buffer */
#define	DKIOCGALARM	_IOR('v', 7, struct alarm)	/* get RTC alarm */
#define	DKIOCSALARM	_IOW('v', 7, struct alarm)	/* set RTC alarm */

#endif	_VIDEO_



