/*
 * Copyright (c) 1992 NeXT Computer, Inc.
 *
 * UFS byte swapping routines to make a big endian file system useful on a
 * little endian machine.
 *
 * HISTORY
 *
 * 8 Jul 1992 Brian Pinkerton at NeXT
 *      Created.
 */
#import <bsd/sys/disktab.h>
#import <bsd/sys/vnode.h>
#import <bsd/sys/buf.h>
#import <bsd/dev/disk.h>
#import <bsd/ufs/fs.h>
#import <bsd/ufs/inode.h>

void byte_swap_ints(int *array, int count);
void byte_swap_shorts(short *array, int count);

void byte_swap_disklabel_out(disk_label_t *dl);
void byte_swap_disklabel_in(disk_label_t *dl);

void byte_swap_disktab_in(struct disktab *dt);
void byte_swap_disktab_out(struct disktab *dt);

void byte_swap_partition(struct partition *part);

void byte_swap_csum(struct csum *cs);
void byte_swap_cylgroup(struct cg *cg);

void byte_swap_inode_in(struct dinode *di, struct inode *ip);
void byte_swap_inode_out(struct inode *ip, struct dinode *dp);

void byte_swap_dir_block_in(char *addr, int count);
void byte_swap_dir_block_out(struct buf *bp);
