/*
**      DBImageView.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/


#import <appkit/Control.h>

@interface DBImageView : Control
{
    id		_image;
    struct {
	unsigned	_style : 4;
	BOOL		_editable : 1;
    } _ivflags;
    id _target;                    // for action messages
    SEL _action;                   // call here after an image drag-drop
}


- initFrame:(const NXRect *)frameRect;
- drawSelf:(const NXRect *)rects :(int)rectCount;

- image;
- setImage:newImage;

- setStyle:(int)newStyle;
- (int)style;
- setEditable:(BOOL)yn;
- (BOOL)isEditable;


typedef enum {
    DB_ImageNoFrame = 0,
    DB_ImagePhoto,
    DB_ImageGrayBezel,
    DB_ImageGroove
} DBImageStyle;


@end


