/*
**      DBModule.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/


#import <objc/Object.h>
#import <objc/hashtable.h>
#import <dbkit/enums.h>		// for failure codes

@class List;


@interface DBModule : Object
{
    id database;
    id delegate;
    id _fetchGroupList;
    id _scratchValue;
    NXHashTable *_associationTable;
    id _editingAssociation;
    id _mainWindow;
    struct {
	int _reserved : 32;
    } _mflags;
    id _reserved;
}

/* Access to structure */
- initDatabase:newDatabase entity:newEntity;
- database;

- entity;

- setDelegate:anObject;
- delegate;

/* client control and configuration */
- addFetchGroup:newFetchGroup;
- fetchGroupNamed:(const char *)searchName;
- getFetchGroups:(List *)returnList;
- rootFetchGroup;
- editingAssociation;
- associationForObject:anObject;
- fetchContentsOf:aSource usingQualifier:aQualifier;

/* target-action methods */
- fetchAllRecords:sender;
- saveChanges:sender;
- discardChanges:sender;
- deleteRecord:sender;
- appendNewRecord:sender;
- insertNewRecord:sender;
- nextRecord:sender;
- previousRecord:sender;
- takeValueFrom:sender;

/* Text delegate methods implemented for tracking edits (editingAssociation) */
- (BOOL)textWillChange:textObject;
- (BOOL)textWillEnd:textObject;
- textDidEnd:textObject endChar:(unsigned short)whyEnd;
@end


/* methods sent to the DBModule's delegate */
@interface Object(DBModuleDelegate)
- (BOOL)moduleWillSave:module;
- moduleDidSave:module;
- (BOOL)moduleWillLoseChanges:module;
@end


