/*
**      customType.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/

/*
** These categories are the mechanism the dbkit uses to place objects into
** the database.  If a class is associated with a property and it implements
** this method, this method will be called when the kit tries to store
** the object into the database.
*/


#define DBFormat_RTF	"RTF"
#define DBFormat_RTFD	"RTFD"
#define DBFormat_TIFF	"TIFF"
#define DBFormat_EPS	"EPS"


@interface Object (DBFormatInitialization)

- initFromBuffer:(void*)buffer ofLength:(unsigned)length
    withFormat:(const char*)aFormatString;

@end

@interface Object (DBFormatConversion)

- writeBuffer:(void**)bufferPtr ofLength:(unsigned*)lengthPtr
    usingFormat:(const char*)aFormatString;

@end


