/*
**      enums.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/

#define DB_NoIndex 0xffffffff

/* operational status of RecordStream and RecordList */
typedef enum _DBRecordRetrievalStatus {
  DB_NotReady,
  DB_Ready,
  DB_FetchInProgress,
  DB_FetchLimitReached,
  DB_FetchCompleted
} DBRecordRetrieveStatus;

/* access strategy used by RecordList */
typedef enum _DBRecordListMode {
  DB_SynchronousStrategy,
  DB_BackgroundStrategy,
  DB_BackgroundNoBlockingStrategy
} DBRecordListRetrieveMode;

/*
** Sort orders
*/
typedef enum {
  DB_NoOrder = 0,
  DB_AscendingOrder,
  DB_DescendingOrder
} DBRetrieveOrder;


/*
** failure codes
*/
typedef enum {
  DB_ReasonUnknown = 0,
  DB_RecordBusy,
  DB_RecordStreamNotReady,
  DB_RecordHasChanged,
  DB_RecordLimitReached,
  DB_NoRecordKey,
  DB_RecordKeyNotUnique,
  DB_NoAdaptor,
  DB_AdaptorError,
  DB_TransactionError
} DBFailureCode;


/*
** failure responses
*/
typedef enum {
  DB_NotHandled = 0,
  DB_Abort,
  DB_Continue
} DBFailureResponse;



