/*
**      tableProtocols.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/
#import <objc/Object.h>
#import <appkit/graphics.h>

/*
 *  This protocol is used to parameterize rows and columns in a table.
 */
@protocol DBTableVectors
- formatter;
- setFormatter:newFormatter;
- (BOOL) isResizable;
- setResizable:(BOOL) isResizable;
- (BOOL) isAutosizable;
- setAutosizable:(BOOL) isAutosizable;
- (BOOL) isEditable;
- setEditable:(BOOL) isEditable;
- (NXCoord) minSize;
- setMinSize:(NXCoord) newMinSize;
- (NXCoord) maxSize;
- setMaxSize:(NXCoord) newMaxSize;
- (NXCoord) size;
- (NXCoord) sizeTo:(NXCoord) newSize;
- (const char *) title;
- setTitle:(const char *) title;
- titleFont;
- setTitleFont:aFont;
-  identifier;
- setIdentifier:anIdentifier;
- (int) titleAlignment;
- setTitleAlignment:(int) align;
- (int) contentAlignment;
- setContentAlignment:(int) align;
@end


@interface Object(DBTableDataSources)
- (unsigned int) rowCount;
- (unsigned int) columnCount;

- getValueFor:identifier at:(unsigned int) aPosition into:aValue;
- setValueFor:identifier at:(unsigned int) aPosition from:aValue;

- getValueFor:rowIdentifier :columnIdentifier into:aValue;
- setValueFor:rowIdentifier :columnIdentifier from:aValue;
@end

