/*
**      types.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/


#import <objc/objc.h>

@class DBValue;

/*
** DBTypes is a grouping of an expression type, an objective-C type, and
**  (optionally) the type that this object had in the database.
**
** The objcType is how the value of the object is actually stored (and coerced,
**  if necessary).  The databaseTypeName is a string that represents the
**  type that the object has in the database; an example might be "Number".
**  The databaseType is completely adaptor dependent.
**
*/

@protocol DBTypes

- (const char*)objcType;
- (const char*)objcClassName;
- (const char*)databaseType;

- (BOOL)matchesType:(id<DBTypes>)aType;

- (BOOL)isEntity;

@end

