/* 	Copyright (c) 1993 NeXT Computer, Inc.  All rights reserved. 
 *
 * IODeviceDescription.h.
 *
 * HISTORY
 * 08-Jan-93    Doug Mitchell at NeXT
 *      Created. 
 */

#import <objc/Object.h>
#import <mach/port.h>
#import <driverkit/IOConfigTable.h>

/*
 * IODeviceDescription object. This is basically a means for the kernel's 
 * autoconfig and device loaders modules to pass a device port, a
 * direct device id, and/or config information to a driver's +probe: method.
 */
@interface IODeviceDescription : Object
{
@private
	port_t		_deviceMaster;	// needed for destroying _devicePort
	port_t		_devicePort;
	id		_directDevice;
	IOConfigTable 	*_configTable;
	
	/*
	 * Other 'config' stuff to be subclassed here.
	 */
}

- init;
- free;
- (port_t)devicePort;
- (void)setDevicePort 		: (port_t)devicePort;
- directDevice;
- (void)setDirectDevice 	: directDevice;
- (void)setDeviceMaster 	: (port_t)deviceMaster;
- (port_t)deviceMaster;
- (void)setConfigTable 		: (IOConfigTable *)configTable;
- (IOConfigTable *)configTable;

@end	/* IODeviceDescription */

