/* 	Copyright (c) 1993 NeXT Computer, Inc.  All rights reserved. 
 *
 * IODirectDevice class description.
 *
 * HISTORY
 * 08-Jan-93    Doug Mitchell at NeXT
 *      Created. 
 */

#import <driverkit/IODevice.h>

@interface IODirectDevice : IODevice
{
@private
	IODeviceDescription	*_deviceDescription;
	port_t			_interruptPort;
}

/*
 * By defintion, all subclasses of this class are of style IO_DirectDevice.
 * Subclasses need not implement this method.
 */
+ (IODeviceStyle)deviceStyle;

- init;
- free;
- deviceDescription;
- (void)setDeviceDescription : deviceDescription;
- (port_t)interruptPort;
- (void)setInterruptPort : (port_t)interruptPort;
- (IOReturn) attachInterruptPort;

@end	/* IODirectDevice */

