/*
 * Copyright (c) 1992 NeXT Computer, Inc.
 *
 * Network interface class.
 *
 * HISTORY
 *
 * 10 December 1992 David E. Bohman at NeXT
 *	Created.
 */

#ifdef	KERNEL

#import <objc/Object.h>
#import <bsd/net/netif.h>

@interface IONetwork:Object
{
@private
    netif_t	_netif;
}

- initForNetworkDevice:device
		name:(const char *)name
		unit:(unsigned int)unit
		type:(const char *)type
		maxTransferUnit:(unsigned int)mtu
		flags:(unsigned int)flags;

- (int)handleInputPacket:(netbuf_t)pkt
		extra:(void *)extra;

- (void)incrementInputPackets;
- (void)incrementOutputPackets;
- (void)incrementInputErrors;
- (void)incrementOutputErrors;
- (void)incrementCollisions;

@end

@protocol IONetworkDeviceMethods

- (int)finishInitialization;

- (int)outputPacket:(netbuf_t)pkt
	    address:(void *)addrs;

- (netbuf_t)allocateNetbuf;

- (int)performCommand:(const char *)command
	    data:(void *)data;

@end

#endif	KERNEL
