/*
** IOVideoDeviceInspector - Inspects display mode for video cards.
**
** Copyright 1993 by NeXT Computer, Inc.  All Rights Reserved.
*/
#import <driverkit/IODeviceInspector.h>

typedef struct _IODisplayMode
{
    int	  width, height;
    int	  refreshRate;
    char  colorSpace[256];
} IODisplayMode;

@interface IOVideoDeviceInspector:IODeviceInspector
{
    id videoAccessoryHolder;
    id displayMode;
    id panel;
    id modes;
    id okButton;
    id selectButton;
    id modeText;
    
    IODisplayMode  *modeRecs;
    unsigned	   modeCount;
}

- init;
- setAccessoryView:aView;
- runPanel:sender;
- panelDone:sender;
- cancel:sender;
- doubleClicked:sender;
- setTable:(NXStringTable *)instance;
@end
