/*
	NIDomainPanel.h
	Copyright 1989, NeXT, Inc.
	Originally Written by: Richard Williamson
	Responsibility: Lee Tucker
*/
#import <appkit/Panel.h>
#import <netinfo/ni.h>
#import "domain.h"

@interface NIDomainPanel : Object
{
	id domainBrowser;
	id okButton;
	id cancelButton;
	id domainText;
	id panel;
	id groupForm;
	id fieldEditor;
	id sharedDomainPanel;
	struct NIHierarchyOfDomains myDomains;
	ni_status lastFailure;
	int exitFlags;
	char returnPath[1024];
	void * currentDomain;
	BOOL domainBrowserLoaded;
	id panelButton;
	NXZone *zone;
	void *_private;
	int	_reservedSpace2;
}

+ new;
+ newWithoutPanel;
+ allocWithoutPanelFromZone:(NXZone *)azone;
- init;

- (int)runModal;
- resizePanelBeforeShowing:(const char *)panelDefaultName;

/* Data extraction methods */
- (int)exitFlags;
- (const char *)domain;
- (const char *)panelSizeDefaultName;

/* Target methods */
- cellWasHitInBrowser: (id)sender;
- cancel: sender;
- ok:sender;

/* IB outlet methods */
- setPanelButton: anObject;

/* Browser construction methods */
- freeLastColumn;
- fillNextColumn;
- loadDomainBrowser;
- loadDomainBrowserFrom:(const char *)whereFrom;

/* textField completion method */
- completeDomain;

/* Text delegate methods */

- text:textObj isEmpty:(BOOL)flag;

/* Browser delegate methods */

- (int)browser:sender fillMatrix:matrix inColumn:(int)column;
- browser:sender loadCell:cell atRow:(int)row inColumn:(int)column;

/* Methods listed for subclassing only */
+ initialize;
- runOk:sender;
- panel;
- textWillChange: textObj;
- (BOOL)textWillEnd: textObj;
- windowDidResize:sender;



@end





