/*
	NIOpenPanel.h
	Copyright 1990, NeXT, Inc.
	Originally Written by: Lee Tucker
	Responsibility: Lee Tucker
*/
#import <appkit/Panel.h>
#import <netinfo/ni.h>
#import "domain.h"
#import "NIDomainPanel.h"

@interface NIOpenPanel : NIDomainPanel
{
	id directoryObjectBrowser;
	char *pathToUse;
	ni_entrylist *filler;
	id listTitleField;
	id panelTitleField;
	id selectedItemText;
	id iconButton;
	int	_reservedSpaceOpen1;
	int	_reservedSpaceOpen2;
	int _reservedSpaceOpen3;
	int _reservedSpaceOpen4;
}

+ new;
- setDirectoryPath:(const char *)dirPath;

/* Data retrieval methods */

- (const char *)directory;
- (const char *)panelSizeDefaultName;

- (int)runModal;

/* target methods */

- cellWasHitInBrowser: (id)sender;
- cellWasHitInItemList:sender;

/* object initialization methods */

- setDirectoryObjectBrowser:anObject;
- refreshLowerData:sender;

- searchItemList: textThing;
- searchTextField;
- completeItemName;

/* IB outlet methods, do not disturb */

- setListTitle: (const char *)title;
- setPanelTitle: (const char *)title;
- setSelectedItemText:anObject; 

/* Methods listed for subclassing only */

- text:textObj isEmpty:(BOOL)flag;
- (BOOL)textWillChange: textObj;
- (int)browser:sender fillMatrix:matrix inColumn:(int)column;
- browser:sender loadCell:cell atRow:(int)row inColumn:(int)column;
- completeDomain;

@end






