/*
 *	objc-load.h
 *	Copyright 1988, NeXT, Inc.
 */

#ifndef _OBJC_LOAD_H_
#define _OBJC_LOAD_H_

#import <objc/objc.h>
#import <objc/objc-class.h>
#import <streams/streams.h>
#import <mach-o/loader.h>

/* dynamically loading Mach-O object files that contain Objective-C code */

extern long objc_loadModules(
	char *moduleList[], 				/* input */
	NXStream *errorStream,				/* input (optional) */
	void (*loadCallback)(Class, Category),		/* input (optional) */
	struct mach_header **headerAddr,		/* output (optional) */
	char *debugFileName				/* input (optional) */
);

extern long objc_unloadModules(
	NXStream *errorStream,				/* input (optional) */
	void (*unloadCallback)(Class, Category)		/* input (optional) */
);

#endif /* _OBJC_LOAD_H_ */
