/*
IXStoreFile.h
Copyright 1991, NeXT Computer, Inc.
*/

#import	"IXStore.h"

@interface IXStoreFile: IXStore
{
    int			descriptor;
    const char		*filename;
    struct		{
	unsigned	needsClose:1;
	unsigned	isCreating:1;
    }			fileStatus;
}

// Releases the flock(), closes the file descriptor and frees the run time 
// representation.

- free;

// Creates a temporary file in /tmp using mktemp(3).  The temporary file is not 
// destroyed when the receiver is freed.

- init;

// Opens the designated file for writing as a store, creating it if necessary.  
// Fails and returns nil if the file exists, but is not formatted as a store.

- initWithFile:(const char *)filename;

// Opens the designated file as a store, for reading or writing according to 
// the second argument.  Fails and returns nil if the file does not exist.

- initFromFile:(const char *)filename forWriting:(BOOL)writingFlag;

- (const char *)filename; // returns the file name.

// Returns the file descriptor.  The file descriptor must remain open until the 
// object is freed, since it is used repeatedly.

- (int)descriptor;

@end

