###############################################################################
#  NeXT specialrules.make
#  Copyright 1992, NeXT Computer, Inc.
#
#  This makefile provides a special set of compilation rules useful in 
#  standalone bundles and palettes.  These rules are necessary to allow 
#  the build of bundles and palettes to be driven by common.make as part of a
#  larger hierarchy of subprojects, as well as be done when bundle.make or
#  palette.make are the top-level Makefiles in the standalone case.
#  
###############################################################################

DEFAULT_CFLAGS = $(ALL_CFLAGS) -I$(SYM_DIR) 

# Rewrite various rules to allow -g for the standalone case

.c.o:
	$(CC) $(DEFAULT_CFLAGS) -c $*.c -o $(OFILE_DIR)/$*.o
.m.o:
	$(CC) $(DEFAULT_CFLAGS) -c $*.m -o $(OFILE_DIR)/$*.o
.C.o:
	$(CC) $(DEFAULT_CFLAGS) $(C++CFLAGS) -c $*.C -o $(OFILE_DIR)/$*.o
.cc.o:
	$(CC) $(DEFAULT_CFLAGS) $(C++CFLAGS) -c $*.cc -o $(OFILE_DIR)/$*.o
.cxx.o:
	$(CC) -ObjC++ $(DEFAULT_CFLAGS) $(C++CFLAGS) -c $*.cxx -o $(OFILE_DIR)/$*.o

.psw.o: $(SYM_DIR)
	$(PSWRAP) $(PSWFLAGS) -a -h $(SYM_DIR)/$*.h -o $(SYM_DIR)/$*.c $*.psw
	$(CC) $(DEFAULT_CFLAGS) -c $(SYM_DIR)/$*.c -o $(OFILE_DIR)/$*.o
.pswm.o: $(SYM_DIR)
	$(PSWRAP) $(PSWFLAGS) -a -h $(SYM_DIR)/$*.h -o $(SYM_DIR)/$*.m $*.pswm
	$(CC) $(DEFAULT_CFLAGS) -c $(SYM_DIR)/$*.m -o $(OFILE_DIR)/$*.o

